; Example of genlib
;
; Show :
;	* Sprite routine 16 x 16
;	* Flip horizontal and vertical for the sprite routine
;	* Window
;	* gray mode
;	* Zoom

; Doen't work realy on HW2
; Since I use tios rom calls !

	include	flib.h
	include	tios.h
	include	hexlib.h
	include genlib.h
	include macros.h

	xdef	_main
	xdef	_comment
	xdef	_ti92plus
	xdef	_ti89

_main:
	jsr	tios::ScreenClear

	jsr	genlib::init_dscreen	; Init a new double screen
	tst.w	d0			; Memory ?
	beq	fail			; yes :<

	move.w	d0,MyHd			; Save the handle
	move.l	a0,Screen		; Save the adress of the dscreen

	jsr	genlib::init		; 4 gray mode

	move.l	Screen(PC),d0
	jsr	genlib::set_dscreen_int
			; the interruption works with the dscreen D0
	jsr	genlib::set_dscreen_function	
			; the functions work with the dscreen D0

	jsr	genlib::cls	; Clear it

	clr.w	genlib::sprite_scr_x	; Clear Sprite_Scroll_X coordinate
	clr.w	genlib::sprite_scr_y	; Clear "_"_Y "
	lea	Sprite_Tile(PC),a0	; Set sprite tile (16x16)
	move.l	a0,genlib::sprite_tile_adr


	moveq	#127,d0
	moveq	#108,d1
	moveq	#0,d2
	jsr	genlib::put_sprite_16	; Put sprite d2.w at (d0.w, d1.w)
					; on the current dscreen !
	moveq	#50,d0
	moveq	#18,d1
	moveq	#0,d2
	jsr	genlib::put_sprite_16_flip_h
					; Put sprite d2.w at (d0.w, d1.w)
					; Horizontal flip
	moveq	#10,d0
	moveq	#40,d1
	moveq	#0,d2
	jsr	genlib::put_sprite_16_flip_v
					; Put sprite d2.w at (d0.w, d1.w)
					; Vertical flip
	moveq	#100,d0
	moveq	#50,d1
	moveq	#0,d2
	jsr	genlib::put_sprite_16_flip_hv
					; Put sprite d2.w at (d0.w, d1.w)
					; Horizontal and vertical flip

	moveq	#100,d0
	moveq	#120,d1
	jsr	genlib::put_sprite_16_last_flip
					; puts last flipped sprite

	WriteStr #0,#0,#4,_comment	; Write something in the Window (LCD_MEM)

	jsr	genlib::copy_window	; Copy the window to the current dscreen

	jsr	genlib::wait_a_key	; Wait a key (direct acces)

	jsr	genlib::cls

	jsr	genlib::wait_no_key

	moveq	#10,d0
	moveq	#15,d1
	moveq	#0,d2
	move.l	#(65536/4),d4
	move.l	#(65536*4),d5
;	jsr	genlib::put_sprite_16_zoom
	
;	jsr	genlib::wait_a_key	; Wait a key (direct acces)

	jsr	genlib::quit		; Restore Black & White mode

	move.w	MyHd(PC),-(a7)
	jsr	tios::HeapFree		; Free allocated buffer for Dscreen
	addq.l	#2,a7
fail:
	rts


MyHd:	dc.w	0
Screen	dc.l	0

Sprite_Tile
	INCBIN "fernand.bin"

_comment:
	dc.b	"Example 1",0
	end
